%% simulate WTP:

clear 
clc

load results_NO_re_02.mat
Results1 = Results;

load results_SE_re_02.mat
Results2 = Results;

B1 = Results1.MXL.bhat; % NO
V1 = Results1.MXL.ihess; % SE

B2 = Results2.MXL.bhat;
V2 = Results2.MXL.ihess;

% This can be time consuming - change both to e.g. 1e4 for less precise but faster results
sim1 = 1e4;
sim2 = 1e4;

NVarA = EstimOpt.NVarA;

bhat1 = mvnrnd(B1,V1,sim1)';
bhat2 = mvnrnd(B2,V2,sim1)';
WTP_i1 = zeros(sim1,16*5);
WTP_i2 = zeros(sim1,16*5);
WTP_i3 = zeros(sim1,16*5);

parfor i = 1:sim1
    bhat1_i = bhat1(:,i);
    bhat2_i = bhat2(:,i);
%     B0_i = mvnrnd(bhat_i(1:NVarA)',diag(bhat_i(NVarA+1:NVarA*2).^2),sim2);
    b01v = bhat1_i(NVarA+1:end)';
    b02v = bhat2_i(NVarA+1:end)';
    VC1 = tril(ones(NVarA));
    VC2 = tril(ones(NVarA));
    VC1(VC1==1) = b01v;
    VC2(VC2==1) = b02v;
    VC1 = VC1*VC1';
    VC2 = VC2*VC2';
    B01_i = mvnrnd(bhat1_i(1:NVarA)',VC1,sim2);
    B02_i = mvnrnd(bhat2_i(1:NVarA)',VC2,sim2);
    WTP_NO_tmp = [zeros(sim2,1), -B01_i(:,1) + B01_i(:,2), -B01_i(:,1) + B01_i(:,3), -B01_i(:,1) + B01_i(:,4),...
                   -B01_i(:,1) + B01_i(:,5), -B01_i(:,1) + B01_i(:,5) + B01_i(:,2), -B01_i(:,1) + B01_i(:,5) + B01_i(:,3), -B01_i(:,1) + B01_i(:,5) + B01_i(:,4),...
                   -B01_i(:,1) + B01_i(:,6), -B01_i(:,1) + B01_i(:,6) + B01_i(:,2), -B01_i(:,1) + B01_i(:,6) + B01_i(:,3), -B01_i(:,1) + B01_i(:,6) + B01_i(:,4),...
                   -B01_i(:,1) + B01_i(:,7), -B01_i(:,1) + B01_i(:,7) + B01_i(:,2), -B01_i(:,1) + B01_i(:,7) + B01_i(:,3), -B01_i(:,1) + B01_i(:,7) + B01_i(:,4)];
    WTP_SE_tmp = [zeros(sim2,1), -B02_i(:,1) + B02_i(:,2), -B02_i(:,1) + B02_i(:,3), -B02_i(:,1) + B02_i(:,4),...
                   -B02_i(:,1) + B02_i(:,5), -B02_i(:,1) + B02_i(:,5) + B02_i(:,2), -B02_i(:,1) + B02_i(:,5) + B02_i(:,3), -B02_i(:,1) + B02_i(:,5) + B02_i(:,4),...
                   -B02_i(:,1) + B02_i(:,6), -B02_i(:,1) + B02_i(:,6) + B02_i(:,2), -B02_i(:,1) + B02_i(:,6) + B02_i(:,3), -B02_i(:,1) + B02_i(:,6) + B02_i(:,4),...
                   -B02_i(:,1) + B02_i(:,7), -B02_i(:,1) + B02_i(:,7) + B02_i(:,2), -B02_i(:,1) + B02_i(:,7) + B02_i(:,3), -B02_i(:,1) + B02_i(:,7) + B02_i(:,4)];
    WTP_ALL_tmp = WTP_NO_tmp + WTP_SE_tmp;
               
    WTP_i1(i,:) = [mean(WTP_NO_tmp) median(WTP_NO_tmp) std(WTP_NO_tmp) quantile(WTP_NO_tmp,0.025), quantile(WTP_NO_tmp,0.975)]; 
    WTP_i2(i,:) = [mean(WTP_SE_tmp) median(WTP_SE_tmp) std(WTP_SE_tmp) quantile(WTP_SE_tmp,0.025), quantile(WTP_SE_tmp,0.975)];
    WTP_i3(i,:) = [mean(WTP_ALL_tmp) median(WTP_ALL_tmp) std(WTP_ALL_tmp) quantile(WTP_ALL_tmp,0.025), quantile(WTP_ALL_tmp,0.975)];
end

Wm1 = median(WTP_i1);
Wm2 = median(WTP_i2);
Wm3 = median(WTP_i3);
Ws1 = std(WTP_i1);
Ws2 = std(WTP_i2);
Ws3 = std(WTP_i3);
Wq11 = quantile(WTP_i1,0.025);
Wq12 = quantile(WTP_i2,0.025);
Wq13 = quantile(WTP_i3,0.025);
Wq21 = quantile(WTP_i1,0.975);
Wq22 = quantile(WTP_i2,0.975);
Wq23 = quantile(WTP_i3,0.975);

RES = [[reshape(Wm1,[4,4*5]);reshape(Ws1,[4,4*5]);reshape(Wq11,[4,4*5]);reshape(Wq21,[4,4*5])],...
    [reshape(Wm2,[4,4*5]);reshape(Ws2,[4,4*5]);reshape(Wq12,[4,4*5]);reshape(Wq22,[4,4*5])],...
    [reshape(Wm3,[4,4*5]);reshape(Ws3,[4,4*5]);reshape(Wq13,[4,4*5]);reshape(Wq23,[4,4*5])]]*10;

